% procedure to assemble left stiffness matrix
% incoming:  	- element number i;
% 		- array unklist; 	this array contains the sequence numbers
%					of the unknowns at the vertices
%					It is a matrix whose number of rows is
%					equal to the total number of nodal points
%					and whose number of columns is 4, where
% 					the last column gives the number of
%					unknowns in an integration point.

for index1 = 1:topology % over all integration points
  for index2 = 1:topology % over all integration points
    ind1 	= elmat(i,index1);
    ind2 	= elmat(i,index2); % gives global node numbers
    ndgf1 	= unklist(ind1,4); % gives number of unknowns
    ndgf2	= unklist(ind2,4);
    for idgf1 = 1:ndgf1
      for idgf2 = 1:ndgf2
        inddgf1 = unklist(ind1,idgf1); % gives sequence number of the unknown
        inddgf2 = unklist(ind2,idgf2);
        SL(inddgf1,inddgf2) = SL(inddgf1,inddgf2) + SLelem(seqarr(index1)+idgf1-1,seqarr(index2)+idgf2-1);
	
        SR(inddgf1,inddgf2) = SR(inddgf1,inddgf2) + SRelem(seqarr(index1)+idgf1-1,seqarr(index2)+idgf2-1);
      end;
    end; 
  end;
end;
