
% Module for element mass matrix for reactive term
%
% Output: felem  ====== vector of two components
%
% felem(1), felem(2) to be computed in this routine.

clear xc
clear yc
bfuelem = zeros(3,1);
bfvelem = zeros(3,1);
bfpelem = zeros(3,1);
bfelem  = zeros(8,1);

for index1 = 1:topologybnd
	xc(index1) = x(elmatbnd(i,index1));
	yc(index1) = y(elmatbnd(i,index1));
end;

lek = sqrt((xc(3)-xc(1))^2+(yc(3)-yc(1))^2);

for index1 = 1:topologylinbnd
	if (yc(2*index1-1) == 8)
		K_B(1) = 0;
		K_B(2) = 0;
		if (abs(xc(2*index1-1) - 4) < 0.8)
			tau(1) = tau_orig(1);
			tau(2) = tau_orig(2);
		else
			tau(1) = 0;
			tau(2) = 0;
		end;
	else
		K_B(1) = K_orig(1);
		K_B(2) = K_orig(2);
		%%%tau(1) = tau_orig(1);
		tau(1) = 0;
		%%%tau(2) = tau_orig(2);
		tau(2) = 0;
	end;
	bfuelem(2*index1-1) = -lek / 6 * (-tau(1) + K_B(1) * u_B);
	bfvelem(2*index1-1) = -lek / 6 * (-tau(2) + K_B(2) * v_B);
end;

if (yc(2) == 8)
	K_B(1) = 0;
	K_B(2) = 0;
	if (abs(xc(2) - 4) < 0.8)
		tau(1) = tau_orig(1);
		tau(2) = tau_orig(2);
	else
		tau(1) = 0;
		tau(2) = 0;
	end;
else
	K_B(1) = K_orig(1);
	K_B(2) = K_orig(2);
	%%%tau(1) = tau_orig(1);
	tau(1) = 0;
	%%%tau(2) = tau_orig(2);
	tau(2) = 0;
end;
bfuelem(2) = -2 / 3 * lek * (-tau(1) + K_B(1) * u_B);
bfvelem(2) = -2 / 3 * lek * (-tau(2) + K_B(2) * v_B);

for index1 = 1:topologylinbnd
	if (yc(2*index1-1) == 0) | ((yc(2*index1-1) == 8) & (abs(xc(2*index1-1)-4) < 0.8))
		K_B(3) = 0;
	else
		K_B(3) = K_orig(3);
	end;
	if (xc(2*index1-1) == 0) | (xc(2*index1-1) == 8)
		K_B(3) = K_orig(3);
	end;
	bfpelem(2*index1-1) = lek / 2 * K_B(3) * p_B * dt;
end;

% Creation of overall boundary element vector

seqarr(1) = 1;
for index1 = 1:topologybnd-1
	ind1 = elmatbnd(i,index1);
	seqarr(index1+1) = seqarr(index1) + unklist(ind1,4);
end;

% seqarr = [1 4 6];

% seqarr contains the indexes of the first unknown (u) at a node

for index1 = 1:topologybnd
	bfelem(seqarr(index1)) = bfuelem(index1);
	bfelem(seqarr(index1)+1) = bfvelem(index1);
end;

for index1 = 1:2
	bfelem(seqarr(2*index1-1)+2) = bfpelem(2*index1-1);
end;
