% GenerateUnklist
% In this routine, the list of unknowns for each nodal point is created.
% unklist(i,j) gives the j-th unknown for the i-th nodal point.
% i = 1 ... number of nodal points
% j = 1 ... 3 unlist(i,3) = 0 at a midpoint of an element where there is no
%                             pressure unknown
% unklist(i,4) = 2 or 3, gives the total number of unknowns at a nodal point.

index3 	= 0;
counter	= 0;

for index1 = 1:ny
  for index2 = 1:nx
    if ( (mod(index1,2) == 1) & (mod(index2,2) == 1) )
      ndgf = 3;
    else 
      ndgf = 2;
    end;
    index3 = index3 + 1;
    unklist(index3,4) = ndgf;
    unklist(index3,1) = counter + 1;
    unklist(index3,2) = counter + 2;
    counter = counter + ndgf;
    if (ndgf == 3)
      unklist(index3,3) = counter;
    else
      unklist(index3,3) = 0;
    end;
  end;
end;